﻿Imports System.Net.Mail
Imports System.IO

Public Class formMenuPrincipal

    Private Function comprobarDuplicadoListBox(ByVal texto As String, ByVal lista As ListBox) As Boolean
        Dim i As Integer
        Dim encontradoIgual As Boolean

        encontradoIgual = False
        For i = 0 To lista.Items.Count - 1
            If LCase(lista.Items(i)) = LCase(texto) Then
                encontradoIgual = True
                comprobarDuplicadoListBox = encontradoIgual
                Exit Function
            End If
        Next i
        comprobarDuplicadoListBox = encontradoIgual
    End Function

    Function tamanoFichero(ByVal rutaFichero As String) As Long
        Dim fichero As New FileInfo(rutaFichero)

        Return fichero.Length
    End Function

    Private Sub guardarDatosINI()
        Try
            Dim objFicherosINI As New FicherosINI(
                Path.Combine(Application.StartupPath, "configuracion.ini"))
            Dim objCifrarRSA As New encriptacionRSA()
            Dim mensaje As String
            Dim adjuntos As String

            objFicherosINI.WriteString("Validación",
                                       "Usuario", txtUsuario.Text)
            objFicherosINI.WriteBoolean("Validación", "Guardar contraseña", opRecordarContrasena.Checked)
            objFicherosINI.WriteString("Validación",
                                       "Puerto", txtPuerto.Text)
            objFicherosINI.WriteString("Validación",
                                       "Servidor", txtServidorSMTP.Text)
            objFicherosINI.WriteBoolean("Validación", "Autenticación", opAutenticacion.Checked)
            objFicherosINI.WriteBoolean("Validación", "SSL", opSSL.Checked)

            If opRecordarContrasena.Checked = True Then
                ' Cifrar/Encriptar la contraseña y guardarla en el INI
                objFicherosINI.WriteString("Validación", "Contraseña",
                    Trim(objCifrarRSA.encriptar128BitRijndael(txtContrasena.Text, "clave_ajpdsoft")))
            Else
                objFicherosINI.WriteString("Validación", "Contraseña", "")
            End If

            objFicherosINI.WriteString("Email", "Email origen", txtEmailOrigen.Text)
            objFicherosINI.WriteString("Email", "Email destino", txtEmailDestino.Text)
            objFicherosINI.WriteString("Email", "Email CC", txtEmailCC.Text)
            objFicherosINI.WriteString("Email", "Email CCO", txtEmailCCO.Text)
            objFicherosINI.WriteString("Email", "Asunto", txtAsunto.Text)
            objFicherosINI.WriteBoolean("Email", "Formato HTML", opFormatoHTML.Checked)
            objFicherosINI.WriteBoolean("Email", "Formato sin formato", opFormatoSinFormato.Checked)

            'Guardar mensaje en fichero
            mensaje = Path.Combine(Application.StartupPath, "mensaje.txt")
            Dim fichero As New StreamWriter(mensaje)
            fichero.WriteLine(Trim(txtMensaje.Text))
            fichero.Close()

            'Guardar adjuntos en fichero
            adjuntos = Path.Combine(Application.StartupPath, "adjuntos.txt")
            Dim ficheroAdjuntos As New StreamWriter(adjuntos)
            For i = 0 To lsAdjuntos.Items.Count - 1
                ficheroAdjuntos.WriteLine(lsAdjuntos.Items(i))
            Next
            ficheroAdjuntos.Close()

        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.OkOnly + MsgBoxStyle.Exclamation)
        End Try
    End Sub

    Public Sub enviarMail(ByVal emailDesde As String,
                            ByVal emailPara As String, ByVal asunto As String,
                            ByVal cuerpoMail As String,
                            ByVal emailCC As String,
                            ByVal emailCCO As String,
                            ByVal usuario As String,
                            ByVal contrasena As String,
                            ByVal puerto As Integer,
                            ByVal servidorSMTP As String,
                            ByVal ssl As Boolean,
                            ByVal autenticacion As Boolean,
                            ByVal listaFicheros As Generic.List(Of String),
                            ByVal formatoHTML As Boolean)

        Dim Msg As New MailMessage
        Dim SMTP As New SmtpClient()
        Dim i As Integer

        System.Windows.Forms.Cursor.Current = Cursors.WaitCursor

        Try
            Msg.From = New System.Net.Mail.MailAddress(
                emailDesde, "", System.Text.Encoding.UTF8)
            Msg.To.Add(emailPara)
            If emailCC <> "" Then
                Msg.CC.Add(emailCC)
            End If
            If emailCCO <> "" Then
                Msg.Bcc.Add(emailCCO)
            End If

            Msg.Subject = CStr(asunto)
            Msg.SubjectEncoding = System.Text.Encoding.UTF8

            Msg.Body = cuerpoMail
            Msg.BodyEncoding = System.Text.Encoding.UTF8
            Msg.IsBodyHtml = formatoHTML

            If autenticacion Then
                SMTP.UseDefaultCredentials = False
                SMTP.Credentials =
                    New System.Net.NetworkCredential(usuario, contrasena)
            Else
                SMTP.UseDefaultCredentials = True
            End If

            For i = 0 To listaFicheros.Count - 1
                Msg.Attachments.Add(New System.Net.Mail.Attachment(
                                    listaFicheros.Item(i)))
            Next

            SMTP.Port = puerto
            SMTP.Host = servidorSMTP
            SMTP.EnableSsl = ssl
            SMTP.DeliveryMethod = Net.Mail.SmtpDeliveryMethod.Network

            SMTP.Send(Msg)

        Catch ex As Exception
            MsgBox(Err.Description, MsgBoxStyle.Critical +
                   MsgBoxStyle.OkOnly)
        Finally
            System.Windows.Forms.Cursor.Current = Cursors.Default
            SMTP = Nothing
            Msg.Dispose()
            GC.Collect()
        End Try
    End Sub


    Private Sub obtenerTamanoFicheros()
        Dim tamanoFicheros As Double
        Dim i As Integer

        'Obtenemos el tamaño de los ficheros adjuntos seleccionados
        For i = 0 To lsAdjuntos.Items.Count - 1
            tamanoFicheros = tamanoFicheros + tamanoFichero(lsAdjuntos.Items(i))
        Next

        'Mostrar en Kilobytes si es menor de un megabyte
        If tamanoFicheros < 1048576 Then
            tamanoFicheros = tamanoFicheros / 1024
            lInfoAdjuntos.Text = "Tamaño de los adjuntos seleccionados: " &
                FormatNumber(tamanoFicheros, 2) + " KB"
        Else
            tamanoFicheros = tamanoFicheros / 1024 / 1024
            lInfoAdjuntos.Text = "Tamaño de los adjuntos seleccionados: " &
                FormatNumber(tamanoFicheros, 1) + " MB"
        End If
    End Sub

    Private Sub formMenuPrincipal_Load(sender As System.Object,
                                       e As System.EventArgs) Handles MyBase.Load

        Dim objFicherosINI As New FicherosINI(
            Path.Combine(Application.StartupPath, "configuracion.ini"))
        Dim objCifrarRSA As New encriptacionRSA()
        Dim ficheroDescripcion As String

        Try
            'Cargamos los valores del fichero de configuracion.ini
            opRecordarContrasena.Checked =
                objFicherosINI.GetBoolean("Validación", "Guardar contraseña", False)
            txtUsuario.Text = objFicherosINI.GetString("Validación", "Usuario", "")
            opRecordarContrasena.Checked =
                objFicherosINI.GetBoolean("Validación", "Guardar contraseña", False)
            opSSL.Checked = objFicherosINI.GetBoolean("Validación", "SSL", True)

            'Desencriptar/descifrar la contraseña y mostrarla
            txtContrasena.Text = objCifrarRSA.desencriptar128BitRijndael(
                objFicherosINI.GetString("Validación",
                                         "Contraseña", ""), "clave_ajpdsoft")

            ficheroDescripcion = Path.Combine(Application.StartupPath, "mensaje.txt")


            txtPuerto.Text = objFicherosINI.GetString("Validación", "Puerto", "587")
            txtServidorSMTP.Text =
                objFicherosINI.GetString("Validación", "Servidor", "smtp.gmail.com")
            opAutenticacion.Checked =
                objFicherosINI.GetBoolean("Validación", "Autenticación", True)

            If opRecordarContrasena.Checked = True Then
                ' Cifrar/Encriptar la contraseña y guardarla en el INI
                txtContrasena.Text = Trim(objCifrarRSA.desencriptar128BitRijndael(
                                         objFicherosINI.GetString("Validación",
                                                              "Contraseña", ""),
                                                              "clave_ajpdsoft"))
            End If

            txtEmailOrigen.Text = objFicherosINI.GetString("Email", "Email origen", "")
            txtEmailDestino.Text = objFicherosINI.GetString("Email", "Email destino", "")
            txtEmailCC.Text = objFicherosINI.GetString("Email", "Email CC", "")
            txtEmailCCO.Text = objFicherosINI.GetString("Email", "Email CCO", "")
            txtAsunto.Text = objFicherosINI.GetString("Email", "Asunto", "")
            opFormatoHTML.Checked = objFicherosINI.GetBoolean("Email", "Formato HTML", True)
            opFormatoSinFormato.Checked = objFicherosINI.GetBoolean("Email", "Formato sin formato", False)

            If File.Exists(ficheroDescripcion) = True Then
                Dim Reader As StreamReader = File.OpenText(ficheroDescripcion)
                Dim fichero As String = Reader.ReadToEnd()
                Reader.Close()
                txtMensaje.Text = fichero
            End If

            'Cargar ficheros adjuntos
            Dim rutaAdjuntos As String = Path.Combine(Application.StartupPath, "adjuntos.txt")
            If File.Exists(rutaAdjuntos) = True Then
                Dim ficheroAdjuntos As New StreamReader(rutaAdjuntos)
                While (ficheroAdjuntos.Peek() > -1)
                    lsAdjuntos.Items.Add(ficheroAdjuntos.ReadLine)
                End While
                ficheroAdjuntos.Close()
                obtenerTamanoFicheros()
            End If

        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.OkOnly + MsgBoxStyle.Exclamation)
        End Try
    End Sub



    Private Sub btQuitar_Click(sender As System.Object,
                               e As System.EventArgs) Handles btQuitar.Click
        If lsAdjuntos.SelectedIndex <> -1 Then
            lsAdjuntos.Items.RemoveAt(lsAdjuntos.SelectedIndex)
            obtenerTamanoFicheros()
        End If
    End Sub

    Private Sub btQuitarTodosAdjuntos_Click(sender As System.Object,
                                            e As System.EventArgs) Handles btQuitarTodosAdjuntos.Click
        lsAdjuntos.Items.Clear()
        obtenerTamanoFicheros()
    End Sub


    Private Sub btAdjuntar_Click(sender As System.Object,
                                 e As System.EventArgs) Handles btAdjuntar.Click
        Dim fichero As String

        If dlFicheros.ShowDialog Then
            For i = 0 To dlFicheros.FileNames.Count - 1
                fichero = dlFicheros.FileNames(i).ToString
                If Not comprobarDuplicadoListBox(fichero, lsAdjuntos) Then
                    lsAdjuntos.Items.Add(fichero)
                End If
            Next
            obtenerTamanoFicheros()
        End If
    End Sub

    Private Sub btEnviarMail_Click(sender As System.Object,
                                   e As System.EventArgs) Handles btEnviarMail.Click
        Dim ficherosAdjuntos As String = ""
        Dim i As Integer
        Dim listaFicheros = New Generic.List(Of String)

        For i = 0 To lsAdjuntos.Items.Count - 1
            listaFicheros.Add(lsAdjuntos.Items(i).ToString)
        Next

        enviarMail(txtEmailOrigen.Text, txtEmailDestino.Text,
                   txtAsunto.Text,
                   txtMensaje.Text, txtEmailCC.Text, txtEmailCCO.Text,
                   txtUsuario.Text, txtContrasena.Text,
                   Integer.Parse(txtPuerto.Text),
                   txtServidorSMTP.Text, opSSL.Checked, opAutenticacion.Checked,
                   listaFicheros, opFormatoHTML.Checked)
    End Sub

    Private Sub btGuardar_Click(sender As System.Object,
                                e As System.EventArgs) Handles btGuardar.Click
        guardarDatosINI()
    End Sub

    Private Sub btCerrar_Click(sender As System.Object,
                               e As System.EventArgs) Handles btCerrar.Click
        End
    End Sub


    Private Sub lWeb_Click(sender As System.Object, e As System.EventArgs) Handles lWeb.Click
        System.Diagnostics.Process.Start("http://www.ajpdsoft.com")
    End Sub

End Class
